;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Bowser Statue, by imamelia
;
; This is a customizable version of the Bowser statue in SMW (sprite BC).
;
; Extra bytes: 1
; Set to $80 to make it start out facing right instead of left.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; defines and tables
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

!Distance            = $0040
!TimeBeforeExplode   = $60

TileDispX:
	db $F8,$00,$00,$F8
TileDispY:
	db $F8,$00
Tilemap:
	db $30,$41
TileProps:
	db $00,$00,$40,$40

FireDispXLo:
	db $10,$F0
FireDispXHi:
	db $00,$FF

JumpXSpeed:
	db $10,$F0

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; main routine wrapper
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

print "INIT ",pc
       LDA !7FAB40,x
       BPL +
       INC !157C,x
+      RTL

print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR SpriteMainRt
	PLB
	RTL

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; main routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SpriteMainRt:
	JSR SubGFX
	LDY $9D
	BNE .Return
	JSL SubOffScreen
	JSL $01B44F|!bankB
	JSL $01802A|!bankB
	LDA !1588,x
	AND #$04
	BEQ +
	STZ !AA,x
+	LDA !1540,x
       DEC
       BEQ .Explode
       LDA !1594,x
       BNE +
	JSR SubSpitFire
       JSL SubHorzPos
       TYA
       CMP !157C,x
       BNE .Return
       LDA !14E0,x
       XBA
       LDA !E4,x
       REP #$20
       SBC $94
       ADC.w #!Distance
       CMP.w #!Distance*2
       SEP #$20
       BCS .Return
       INC !1594,x
       LDA #!TimeBeforeExplode
       STA !1540,x
+      LDA $14
       LSR #2
       AND #$03
       TAY
       LDA FlashPalettes,y
       STA !15F6,x
.Return
	RTS

.Explode
       LDA #$09
       STA $1DFC|!addr
       LDA #$0D
       STA !9E,x
       LDA #$08
       STA !14C8,x
       JSL $07F7D2|!bankB
       LDA #$4F
       STA !1540,x
       INC !1534,x
       RTS

FlashPalettes:
       db $03,$05,$07,$09

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; graphics routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SubGFX:
	JSL GetDrawInfo
	LDA !15F6,x
	STA $05
	LDA !157C,x
	STA $02

	LDX #$01
.Loop
	PHX
	LDA $02
	BNE .FacingLeft
	INX #2
.FacingLeft
	LDA $00
	CLC
	ADC TileDispX,x
	STA $0300|!addr,y
	LDA TileProps,x
	ORA $05
	ORA $64
	STA $0303|!addr,y
	PLX
	LDA $01
	CLC
	ADC TileDispY,x
	STA $0301|!addr,y
	LDA Tilemap,x
	STA $0302|!addr,y
	INY #4
	DEX
	BPL .Loop
	LDX $15E9|!addr
	LDY #$02
	LDA #$01
	JSL $01B7B3|!bankB
	RTS

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; subroutines
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;------------------------------------------------
; fire-spitting subroutine
;------------------------------------------------

SubSpitFire:
	TXA
	ASL #2
	ADC $14
	AND #$7F
	BNE .Return
	JSL $02A9E4|!bankB
	BMI .Return
	LDA #$17
	STA $1DFC|!addr
	LDA #$08
	STA !14C8,y
	LDA #$B3
	STA.w !9E,y
	LDA !E4,x
	STA $00
	LDA !14E0,x
	STA $01
	LDA !157C,x
	TAX
	LDA $00
	CLC
	ADC FireDispXLo,x
	STA.w !E4,y
	LDA $01
	ADC FireDispXHi,x
	STA !14E0,y
	TYX
	JSL $07F7D2|!bankB
	LDX $15E9|!addr
	LDA !D8,x
	SEC
	SBC #$02
	STA.w !D8,y
	LDA !14D4,x
	SBC #$00
	STA !14D4,y
	LDA !157C,x
	STA !157C,y
.Return
	RTS

